zoukankan      html  css  js  c++  java
  • Codeforces Round #338 (Div. 2) B. Longtail Hedgehog dp

    B. Longtail Hedgehog

    题目连接:

    http://www.codeforces.com/contest/615/problem/B

    Description

    This Christmas Santa gave Masha a magic picture and a pencil. The picture consists of n points connected by m segments (they might cross in any way, that doesn't matter). No two segments connect the same pair of points, and no segment connects the point to itself. Masha wants to color some segments in order paint a hedgehog. In Mashas mind every hedgehog consists of a tail and some spines. She wants to paint the tail that satisfies the following conditions:

    Only segments already presented on the picture can be painted;
    The tail should be continuous, i.e. consists of some sequence of points, such that every two neighbouring points are connected by a colored segment;
    The numbers of points from the beginning of the tail to the end should strictly increase.
    Masha defines the length of the tail as the number of points in it. Also, she wants to paint some spines. To do so, Masha will paint all the segments, such that one of their ends is the endpoint of the tail. Masha defines the beauty of a hedgehog as the length of the tail multiplied by the number of spines. Masha wants to color the most beautiful hedgehog. Help her calculate what result she may hope to get.

    Note that according to Masha's definition of a hedgehog, one segment may simultaneously serve as a spine and a part of the tail (she is a little girl after all). Take a look at the picture for further clarifications.

    Input

    First line of the input contains two integers n and m(2 ≤ n ≤ 100 000, 1 ≤ m ≤ 200 000) — the number of points and the number segments on the picture respectively.

    Then follow m lines, each containing two integers ui and vi (1 ≤ ui, vi ≤ n, ui ≠ vi) — the numbers of points connected by corresponding segment. It's guaranteed that no two segments connect the same pair of points.

    Output

    Print the maximum possible value of the hedgehog's beauty

    Sample Input

    8 6
    4 5
    3 5
    2 5
    1 2
    2 8
    6 7

    Sample Output

    9

    Hint

    题意

    给你一个图,然后你可以选择连续的一段,成为刺猬的脊梁,这个脊梁的要求是点上的编号必须依次增大

    然后他的贡献是这个脊梁的长度*脊梁最后一个点的边数。

    问你这个图最大的贡献是多少

    题解:

    直接dp处理就好了,dp[i]表示到i点的最长长度,很显然dp[i] = max(dp[i],dp[j]+1)(j<i)

    然后从小到大一直跑就好了

    代码

    #include<bits/stdc++.h>
    using namespace std;
    #define maxn 100005
    int dp[maxn];
    vector<int> E[maxn];
    int cnt[maxn];
    int main()
    {
        int n,m;
        scanf("%d%d",&n,&m);
        for(int i=1;i<=m;i++)
        {
            int x,y;scanf("%d%d",&x,&y);
            if(x<y)swap(x,y);
            E[x].push_back(y);
            cnt[x]++,cnt[y]++;
        }
        long long ans = 0;
        for(int i=1;i<=n;i++)
        {
            for(int j=0;j<E[i].size();j++)
                dp[i]=max(dp[i],dp[E[i][j]]);
            dp[i]++;
            ans = max(ans,1LL*dp[i]*cnt[i]);
        }
        cout<<ans<<endl;
    }
  • 相关阅读:
    实验二
    实验一简单的加减乘除
    自我简介
    软件工程——第五次博客作业
    《软件测试》--第四次博客作业
    软件测试 第三次作业
    软件测试 第二次作业
    个人简介
    软件测试 第一次测评
    AE CC 装不上,安装程序检测到计算机重新启动的过程可能暂停。建议退出安装程序,重新启动计算机,然后再重试。
  • 原文地址:https://www.cnblogs.com/qscqesze/p/5115457.html
Copyright © 2011-2022 走看看